[WINE] Protocol (sqrl://) not registering with Firefox 64.0


Status
Not open for further replies.

mollusk

New member
Dec 16, 2018
1
1
USA
Wine Version: 3.21 (32-bit)
SQRL Version: : Release 62 (0.0.6917.62)
Firefox Version: 64.0


What Works:

  • Printing via cups
  • Generating Identity
  • All other basic functions
What does not work:

  • Using identities via Firefox (and presumably other browsers)

I only tried this on Void Linux and not other distributions. If anyone has no problem getting Firefox to recognize the SQRL protocol on other distros, let me know and I will see if I am missing any packages.
 
  • Like
Reactions: 1 person

PHolder

Well-known member
May 19, 2018
1,141
185
Firefox 3.5 and above

(Works without installed Gnome libraries)

  • Type about:config into the Location Bar (address bar) and press Enter.
  • Right-click -> New -> Boolean -> Name: network.protocol-handler.expose.sqrl -> Value -> false
  • Next time you click a link of protocol-type sqrl you will be asked which application to open it with.
This is my edit of the instructions from the page @shanedk linked above. I have not verified that this works.
 
  • Like
Reactions: KenRS and djosr

PHolder

Well-known member
May 19, 2018
1,141
185
From the page, linked above:

All Firefox versions

(Requires certain Gnome libraries to be installed)

  • In a terminal, type:
gconftool-2 -s /desktop/gnome/url-handlers/sqrl/command '/path/to/sqrl.exe %s' --type String
gconftool-2 -s /desktop/gnome/url-handlers/sqrl/enabled --type Boolean true


It's up to you to figure out how to get gconftool installed if it is not already (hopefully it's something your distro has packaged) and then the part in the single quotes above (currently '/path/to/sqrl.exe %s' ) represents the part you need to put your Wine invocation. The %s will be replaced with the SQRL:// url when invoked by the browser.

Good luck.
 

Steve

Administrator
Staff member
May 6, 2018
1,011
304
www.grc.com
Paul: Thanks for your sleuthing. This info should be maintained somewhere here, shouldn't it? I suppose it could be pinned at the top of the "GRC's SQRL Client" where this thread was started. Or should we have a SQRL on WINE forum? I might go at the end of the "General General Topics" section.
 

PHolder

Well-known member
May 19, 2018
1,141
185
should we have a SQRL on WINE forum
Probably should have a pinned thread under each client known to work? It might be interesting to have some HTML somewhere labelled "Getting SQRL" and it could be like a little wizard: Click platform (Windows, Mac, Linux, iOS, Android) which leads to a further question like use it where (stand-alone, in browser, in Wine) and then could list each known client with links to their topics in the forums which should have pinned topics on how to get/install those clients.
 

martin.sqrl

New member
Feb 4, 2019
4
0
Probably should have a pinned thread under each client known to work? It might be interesting to have some HTML somewhere labelled "Getting SQRL" and it could be like a little wizard: Click platform (Windows, Mac, Linux, iOS, Android) which leads to a further question like use it where (stand-alone, in browser, in Wine) and then could list each known client with links to their topics in the forums which should have pinned topics on how to get/install those clients.
As a new sqrl fan, that would be very timely. It took me ages to find Steve's webpage hosting sqrl.exe!

Ps. Thanks for the wine tip (above). Will try it tomorrow.

Martin
 

Steve

Administrator
Staff member
May 6, 2018
1,011
304
www.grc.com
It took me ages to find Steve's webpage hosting sqrl.exe!
Sorry to make you search, Martin. However, this was deliberate. I fully expect that we're going to be SWAMPED when I loudly and clearly tell everyone where they can go to get and play with it. So, as they say, an ounce of prevention... :p
 

shanedk

Well-known member
May 20, 2018
408
107
Some point so long ago it was probably the last ice age, I wrote a script to do this that I think might have been working at some point (although I make no guarantees):

EDIT: This has been updated to work more reliably and deal with various error conditions.

Bash:
#!/bin/bash

# We want to start off by making sure both WINE and
# the xdg-desktop-menu tool are available.

if ! [ -x "$(command -v wine)" ]; then
    echo 'Error: sqrl.exe requires WINE, which is not installed.' >&2
    exit 127
fi

if ! [ -x "$(command -v xdg-desktop-menu)" ]; then
    echo 'Error: This script requires the xdg-desktop-menu tool, which is not installed.' >&2
    exit 127
fi

# Then, let's check the current directory for the
# sqrl.exe file. If it's not there, then we'll see
# if the wget command is installed. We'll throw an
# error if neither of these is the case; otherwise
# we'll use wget to download the latest sqrl.exe
# from grc.com.

if [ ! -f sqrl.exe ]; then
    if ! [ -x "$(command -v wget)" ]; then
      echo 'Error: This script requires wget, which is not installed, or you can manually download sqrl.exe from grc.com and place it in the current directory.' >&2
      exit 127
    fi
    wget https://www.grc.com/dev/sqrl.exe
fi

# All being well, we run the installation.

wine sqrl.exe -install >/dev/null 2>/dev/null

# There's some sort of delay between the SQRL
# installation returning control to the script
# and creating the sqrl.exe file in the destination
# directory, which can result in problems. There's
# no human interaction in the interim, so a 5-second
# delay should be plenty of time to cover it.

sleep 5

# Now let's find exactly where the installation put
# the sqrl.exe file, which will be in the GRC
# directory in Program Files. Since we don't know
# exactly where WINE is installed, we just do a
# search. It's doubtful the user would have run the
# script from more than 4 directories down from the
# home directory, so that should be a good place to
# search from.

sqrlexe=$(find ~ -mindepth 4 -name 'sqrl.exe')

# If the installation failed, then the $sqrlexe
# variable will be blank. We'll check for that and
# throw an error if it's the case.

if [ -z "$sqrlexe" ]; then
    echo 'Error: SQRL did not install correctly.' >&2
    exit 1
fi

# Everything should be good to go! We'll create the
# .desktop file in the current directory and install
# it.

echo "[Desktop Entry]" > grc-sqrl.desktop
echo "Name=SQRL" >> grc-sqrl.desktop
echo "Type=application" >> grc-sqrl.desktop
echo "Exec=wine '$sqrlexe' %u" >> grc-sqrl.desktop
echo "Categories=Internet" >> grc-sqrl.desktop
echo "Terminal=false" >> grc-sqrl.desktop
echo "MimeType=x-scheme-handler/sqrl" >> grc-sqrl.desktop
xdg-desktop-menu install grc-sqrl.desktop

# Is it possible we might want to delete
# grc-sqrl.desktop and sqrl.exe from the current
# directory when we're done? If so, this is where the
# commands would go. Otherwise, it's the end of the
# script.

#
# rm grc-sqrl.desktop >/dev/null 2>/dev/null
# rm sqrl.exe >/dev/null 2>/dev/null
#
 
Last edited:

jhmorimoto

New member
Feb 12, 2019
3
0
Some point so long ago it was probably the last ice age, I wrote a script to do this that I think might have been working at some point (although I make no guarantees):


Bash:
#!/bin/bash

if [ ! -f sqrl.exe ]
then
    echo "The sqrl.exe install file must be in the current directory."
    exit
fi

wine sqrl.exe -install

sqrlexe=$(find ~ -mindepth 4 -name 'sqrl.exe')

echo "[Desktop Entry]" > grc-sqrl.desktop
echo "Name=SQRL" >> grc-sqrl.desktop
echo "Type=application" >> grc-sqrl.desktop
echo "Exec=wine '$sqrlexe' %u" >> grc-sqrl.desktop
echo "Categories=Internet" >> grc-sqrl.desktop
echo "Terminal=false" >> grc-sqrl.desktop
echo "MimeType=x-scheme-handler/sqrl" >> grc-sqrl.desktop

xdg-desktop-menu install grc-sqrl.desktop
Works like a charm, @shanedk. Thanks. This pretty much covers any browser, not only Firefox.
 

Martin Holmes

New member
Feb 17, 2019
4
6
I couldn't get this to work at all, on Ubuntu 18.04.2 LTS with wine. I see only this when I try to run the setup script:

Code:
00ae:err:wininet:open_http_connection create_netconn failed: 12029
find: ‘/home/mholmes/.cache/dconf’: Permission denied
find: ‘/home/mholmes/.dbus’: Permission denied
The first error is the problem, presumably. I see lots of references to it on the Web, but mainly with regard to running games under Wine (which I don't do). Does anyone have any suggestions?

I'm currently logged in using Steve's client on a Windows vm, which is working perfectly.
 

Dl4jones

New member
Nov 21, 2018
4
0
77
Carlsbad CA
Some point so long ago it was probably the last ice age, I wrote a script to do this that I think might have been working at some point (although I make no guarantees):


Bash:
#!/bin/bash

if [ ! -f sqrl.exe ]
then
    echo "The sqrl.exe install file must be in the current directory."
    exit
fi

wine sqrl.exe -install

sqrlexe=$(find ~ -mindepth 4 -name 'sqrl.exe')

echo "[Desktop Entry]" > grc-sqrl.desktop
echo "Name=SQRL" >> grc-sqrl.desktop
echo "Type=application" >> grc-sqrl.desktop
echo "Exec=wine '$sqrlexe' %u" >> grc-sqrl.desktop
echo "Categories=Internet" >> grc-sqrl.desktop
echo "Terminal=false" >> grc-sqrl.desktop
echo "MimeType=x-scheme-handler/sqrl" >> grc-sqrl.desktop

xdg-desktop-menu install grc-sqrl.desktop
On my Mac - when I ran wine sqrl.exe -install in Terminal.app many error messages were generated. I got the grc-sqrl.desktop file built but the xdg-desktop-menu install grc-sqrl.desktop command didn't work on the MacOS version on unix. So this script is not good for the Mac version of unix.
 

DiSTURBED_oNE

Member
Jul 1, 2019
5
0
Does anyone have any information for configuring the SQRL URL schema in Chrome? or Safari?

I am on a mac using Wine.
I have googled for instructions on setting up additional url schemas in Chrome, however, so far haven't found anything.

Also, I am seeing mentioned on the forums an SQRL Chrome extension, however, when searching the Chrome Webstore shows only three results for SQRL, none of which are related to GRCs SQRL.
 
Status
Not open for further replies.